#ifndef __TYPES_H__
#define __TYPES_H__

#if defined (__x86_32__) 

typedef struct {
    long ebx;
    long ecx;
    long edx;
	long esi;
	long edi;
	long ebp;
	long eax;
	int  ds;
	int  es;
	long orig_eax;
	long eip;
	int  cs;
	long eflags;
	long esp;
	int  ss;
} regs_t;

typedef struct { unsigned long pte_low, pte_high; } pte_t;
#define __pte(x) ({unsigned long long _x = x; \
    ((pte_t) {(unsigned long)_x, (unsigned long)(_x >> 32)}); })

typedef unsigned long mfn_t;
typedef unsigned long pfn_t;

#elif defined (__x86_64__)

typedef struct {
	unsigned long r15;
	unsigned long r14;
	unsigned long r13;
	unsigned long r12;
	unsigned long rbp;
	unsigned long rbx;
 	unsigned long r11;
	unsigned long r10;	
	unsigned long r9;
	unsigned long r8;
	unsigned long rax;
	unsigned long rcx;
	unsigned long rdx;
	unsigned long rsi;
	unsigned long rdi;
	unsigned long orig_rax;
	unsigned long rip;
	unsigned long cs;
	unsigned long eflags; 
	unsigned long rsp;
	unsigned long ss;
} regs_t;


typedef struct { unsigned long pte; } pte_t;
#define __pte(x) ((pte_t){x})

typedef unsigned long mfn_t;
typedef unsigned long pfn_t;

#endif

#define PAGE_SIZE 12
#define NULL 0

#endif
