#include <xen/arch-x86_32.h>

// XEN Metadata
.section __xen_guest
    .ascii	"GUEST_OS=Nano-OS"
    .ascii	",XEN_VER=xen-3.0"
    .ascii	",VIRT_BASE=0x0"
    .ascii	",ELF_PADDR_OFFSET=0x0"
    .ascii	",HYPERCALL_PAGE=0x2"
    .ascii	",PAE=yes"
    .ascii	",LOADER=generic"
    .byte	0
.text

.globl _start, shared_info, hypercall_page

// Initial entry point                        
_start:
    cld                   // Clear the direction flag
    lss stack_start, %esp // Load the stack segment
    push %esi             // Setup start info for start_kernel
    call start_kernel     // Jump into the kernel

// Initial stack space
stack_start:
	.long stack+8192, FLAT_KERNEL_SS

    /* Unpleasant -- the PTE that maps this page is actually overwritten */
    /* to map the real shared-info page! :-)                             */
    .org 0x1000
shared_info:

    .org 0x2000
hypercall_page:

    .org 0x3000
