#include <stdint.h>
#include <xen/xen.h>
#include "console.h"
#include "hypercall.h"

// Reserve space for the stack
char stack[8192];

// Main kernel entry point, called by trampoline
void
start_kernel(start_info_t *start_info) {
	HYPERVISOR_console_io(CONSOLEIO_write, 19, "Nano-OS booting...\n");

	console_init(start_info);
	console_write("Hello, world!\r\n");

	while (1);
}
